<template>
    <div class="card border-info mt-4">
        <div class="card-header">Address Validator</div>
        <div class="card-body">
            <form>
                <div class="form-group row">
                    <div class="col-sm-12">
                        <div class="input-group">
                            <input 
                                class="form-control" 
                                v-bind:class="{ 'is-invalid': hasError }" 
                                type="text" 
                                placeholder="Search" 
                                v-model="addressInput" />
                            <div class="input-group-append">
                                <button 
                                    class="btn btn-primary" 
                                    type="button" 
                                    v-on:click="getAddress"
                                >
                                    <i class="fas fa-search"></i>
                                </button>
                            </div>
                            <div class="invalid-feedback">Address could not be found</div>
                        </div>
                    </div>
                </div>

                <hr />

                <div class="form-group row">
                    <label class="col-sm-2"><strong>Street Address</strong></label>
                    <div class="col-sm-10">
                        <input 
                            class="form-control" 
                            type="text" 
                            readonly 
                            placeholder="Street Address" 
                            v-model="address.street" />
                        <div class="invalid-feedback">Address could not be found</div>
                    </div>
                </div>

                <div class="form-group row">
                    <label class="col-sm-2"><strong>City</strong></label>
                    <div class="col-sm-10">
                        <input 
                            class="form-control" 
                            type="text" 
                            readonly 
                            placeholder="City" 
                            v-model="address.city" />
                    </div>
                </div>

                <div class="form-group row">
                    <label class="col-sm-2"><strong>State</strong></label>
                    <div class="col-sm-10">
                        <input 
                            class="form-control"
                            type="text"
                            readonly placeholder="State"
                            v-model="address.state" />
                    </div>
                </div>

                <div class="form-group row">
                    <label class="col-sm-2"><strong>Zip Code</strong></label>
                    <div class="col-sm-10">
                        <input 
                            class="form-control" 
                            type="number" 
                            readonly 
                            placeholder="Zip Code" 
                            v-model="address.zipCode" />
                    </div>
                </div>
            </form>
        </div>
        
        <div class="card-footer">
            <small 
                class="float-right" 
                v-isVisible="showMessage">Checking...</small>
        </div>
    </div>
</template>


<script>
export default {
    data () {
        return  {
            addressInput: '',
            address: {
                street: '',
                city: '',
                state: '',
                zipCode: ''
            },
            hasError: false,
            showMessage: false
        }
    },

    methods: {
        getAddress: function() {
            this.showMessage = true;

            fetch(`https://us-street.api.smartystreets.com/street-address?street=${encodeURIComponent(this.addressInput)}&auth-id=94350710853750949`)
                .then(response => response.json())
                .then(result => {
                    this.showMessage = false;

                    if (result && result.length) {
                        this.hasError = false;

                        this.address.street = result[0].delivery_line_1
                        this.address.city = result[0].components.city_name;
                        this.address.state = result[0].components.state_abbreviation;
                        this.address.zipCode = result[0].components.zipcode;
                    }
                    else {
                        this.hasError = true;
                    }
                })
                .catch(() => {
                    this.hasError = true;
                });
        }
    }
}
</script>
